"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const zhin_1 = require("zhin");
const plugin = new zhin_1.Plugin('Github');
plugin.waitServices('server', 'database');
const config = plugin.useConfig('github', zhin_1.Schema.object({
    appId: zhin_1.Schema.string('Github AppId').required(),
    appSecret: zhin_1.Schema.string('Github AppSecret').required(),
    path: zhin_1.Schema.string('webhook路径').default('/github'),
    messagePrefix: zhin_1.Schema.string('消息前缀'),
    redirect: zhin_1.Schema.string('请求回调地址').default('/redirect'),
    promptTimeout: zhin_1.Schema.number('会话超时时间').default(60000),
    replyTimeout: zhin_1.Schema.number('回复超时时间').default(60000),
    requestTimeout: zhin_1.Schema.number('请求超时时间').default(60000),
}));
plugin.mounted(app => {
    plugin.middleware(async (_a, _b, message, next) => {
        await next();
        const mathReg = /^(?:https?:\/\/)?(?:www\.)?github\.com\/([^/]+)\/([^/]+)\/?$/;
        const match = message.raw_message.match(mathReg);
        if (!match)
            return;
        const [, owner, repo] = match;
        const src = `https://opengraph.github.com/repo/${owner}/${repo}`;
        await message.reply((0, zhin_1.segment)('image', { src }));
    });
});
exports.default = plugin;
