"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transform = transform;
const zhin_1 = require("zhin");
const marked_1 = require("marked");
function renderToken(token) {
    if (token.type === 'code') {
        return token.text + '\n';
    }
    else if (token.type === 'paragraph') {
        return render(token.tokens);
    }
    else if (token.type === 'image') {
        return (0, zhin_1.segment)('image', { src: token.href }).toString();
    }
    else if (token.type === 'blockquote') {
        return token.text;
    }
    return token.raw;
}
function render(tokens) {
    return tokens.map(renderToken).join('');
}
function transform(source) {
    if (!source)
        return '';
    source = source.replace(/^<!--(.*)-->$/gm, '');
    return render(marked_1.marked.lexer(source))
        .trim()
        .replace(/\n\s*\n/g, '\n');
}
